<?php

namespace App\Entity;

use App\Repository\GeoImageRepository;
use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping as ORM;
use JsonSerializable;

#[ORM\Entity(repositoryClass: GeoImageRepository::class)]
#[ORM\Table(name: 'geo_immagine_catasto')]
class GeoImage implements JsonSerializable
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\Column(length: 255)]
    private ?string $filename = null;

    #[ORM\Column(type: Types::JSON, name: 'poligono')]
    private ?string $polygon = null;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function setId(string $id): static
    {
        $this->id = $id;

        return $this;
    }

    public function getFilename(): ?string
    {
        return $this->filename;
    }

    public function setFilename(string $filename): static
    {
        $this->filename = $filename;

        return $this;
    }

    public function getPolygon(): ?string
    {
        return $this->polygon;
    }

    public function setPolygon(string $polygon): static
    {
        $this->polygon = $polygon;

        return $this;
    }

    public function jsonSerialize(): mixed
    {
        return [
            'filename' => $this->filename,
            'polygon' => $this->polygon,
        ];
    }
}
